Subject: devscripts: debuild: please warn about improbable build targets

From: Jiri Palecek <[email-masked]>
Date: Thu, 13 Jun 2019 16:44:10 +0200

Package: devscripts
Version: 2.19.5
Severity: normal
File: /usr/bin/debuild

Dear Maintainer,

while running gbp buildpackage on a package, the package didn't build
with enigmatic output - it said it ran "dh auto check", whcih succeeded
and that was all.

Subsequently, I discovered it was because I accidentally ran it like
this:

gbp buildpackage -- -b

where I should have done

gbp buildpackage -b

Gbp invoked debuild and debuild ran
"dpkg-buildpackage --rules-target -b" which is obviously wrong. It would
be nice if debuild could detect that -b (or anything starting with a
dash) is not a likely target and at least warn with a message, or
abort. Maybe it could be tightened to only allow known targets (binary,
clean, ...), but I'm not sure about that.

I think debuild is the right spot to place a warning in this scenario,
because it actually interprets the arguments as targets, whereas gbp
merely shoves the arguments to the next tool.

Regards
    Jiri Palecek

-- Package-specific info:

-- System Information:
Debian Release: 10.0
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable-debug'), (500, 'testing-debug'), (500, 'unstable'), (1, 'experimental-debug'), (1, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 4.18.0-rc6-bughunt+ (SMP w/2 CPU cores)
Kernel taint flags: TAINT_PROPRIETARY_MODULE, TAINT_WARN, TAINT_OOT_MODULE
Locale: LANG=cs_CZ, LC_CTYPE=cs_CZ (charmap=ISO-8859-2), LANGUAGE=cs_CZ (charmap=ISO-8859-2)
Shell: /bin/sh linked to /bin/dash
Init: systemd (via /run/systemd/system)

Versions of packages devscripts depends on:
ii  dpkg-dev              1.19.6
ii  fakeroot              1.23-1
ii  file                  1:5.35-4
ii  gnupg                 2.2.12-1
ii  gpgv                  2.2.12-1
ii  libc6                 2.28-10
ii  libfile-homedir-perl  1.004-1
ii  libfile-which-perl    1.23-1
ii  libipc-run-perl       20180523.0-1
ii  libmoo-perl           2.003004-1
ii  libwww-perl           6.36-1
ii  patchutils            0.3.4-2
ii  perl                  5.28.1-6
ii  python3               3.7.3-1
ii  sensible-utils        0.0.12
ii  wdiff                 1.2.2-2+b1

Versions of packages devscripts recommends:
ii  apt                         1.8.2
ii  at                          3.1.23-1
ii  curl                        7.64.0-3
ii  dctrl-tools                 2.24-2+b1
pn  debian-keyring              <none>
ii  dput                        1.0.1
ii  equivs                      2.2.0
ii  libdistro-info-perl         0.21
ii  libdpkg-perl                1.19.6
ii  libencode-locale-perl       1.05-1
pn  libgit-wrapper-perl         <none>
pn  libgitlab-api-v4-perl       <none>
pn  liblist-compare-perl        <none>
ii  liblwp-protocol-https-perl  6.07-2
ii  libsoap-lite-perl           1.27-1
pn  libstring-shellquote-perl   <none>
ii  libtry-tiny-perl            0.30-1
ii  liburi-perl                 1.76-1
ii  licensecheck                3.0.31-2
ii  lintian                     2.15.0
it  man-db                      2.8.5-2
ii  patch                       2.7.6-3
ii  python3-apt                 1.8.4
ii  python3-debian              0.1.35
ii  python3-magic               2:0.4.15-1
ii  python3-requests            2.21.0-1
pn  python3-unidiff             <none>
pn  python3-xdg                 <none>
ii  strace                      4.26-0.2
ii  unzip                       6.0-23
ii  wget                        1.20.1-1.1
ii  xz-utils                    5.2.4-1

Versions of packages devscripts suggests:
pn  adequate                                  <none>
ii  autopkgtest                               5.11~1.gbpfc8d61
pn  bls-standalone                            <none>
ii  bsd-mailx [mailx]                         8.1.2-0.20180807cvs-1
ii  build-essential                           12.6
pn  check-all-the-things                      <none>
pn  cvs-buildpackage                          <none>
ii  debhelper                                 12.1.1
ii  devscripts-el                             40.3
ii  diffoscope                                108
pn  disorderfs                                <none>
ii  dose-extra                                5.0.1-11+b3
pn  duck                                      <none>
pn  faketime                                  <none>
pn  gnuplot                                   <none>
pn  how-can-i-help                            <none>
pn  libauthen-sasl-perl                       <none>
pn  libdbd-pg-perl                            <none>
ii  libfile-desktopentry-perl                 0.22-1
pn  libnet-smtps-perl                         <none>
pn  libterm-size-perl                         <none>
ii  libtimedate-perl                          2.3000-2
ii  libyaml-syck-perl                         1.31-1+b1
ii  mozilla-devscripts                        0.48
ii  mutt                                      1.10.1-2.1
ii  openssh-client [ssh-client]               1:7.9p1-10
pn  piuparts                                  <none>
ii  postgresql-client-11 [postgresql-client]  11.3-1
ii  quilt                                     0.65-1~12.gbp4c54b0
pn  ratt                                      <none>
pn  reprotest                                 <none>
pn  svn-buildpackage                          <none>
ii  w3m                                       0.5.3-36+b1

-- no debconf information